Package io.vertx.core.net

## Class OpenSSLEngineOptions

- java.lang.Object
- - io.vertx.core.net.SSLEngineOptions
  - - io.vertx.core.net.OpenSSLEngineOptions

-     public class OpenSSLEngineOptions
      extends SSLEngineOptions

  Configures a `TCPSSLOptions` to use OpenSsl.
  Author:
    Julien Viet

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static boolean` | `DEFAULT_SESSION_CACHE_ENABLED` | Default value of whether session cache is enabled in open SSL session server context = true

    - ### Fields inherited from class io.vertx.core.net.SSLEngineOptions

      `DEFAULT_USE_WORKER_POOL`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `OpenSSLEngineOptions()` |
    `OpenSSLEngineOptions​(JsonObject json)` |
    `OpenSSLEngineOptions​(OpenSSLEngineOptions other)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `OpenSSLEngineOptions` | `copy()` |
    `static boolean` | `isAlpnAvailable()` |
    `static boolean` | `isAvailable()` |
    `boolean` | `isSessionCacheEnabled()` | Whether session cache is enabled in open SSL session server context
    `OpenSSLEngineOptions` | `setSessionCacheEnabled​(boolean sessionCacheEnabled)` | Set whether session cache is enabled in open SSL session server context
    `OpenSSLEngineOptions` | `setUseWorkerThread​(boolean useWorkerThread)` | Set the thread pool to use for SSL blocking operations.
    `SslContextFactory` | `sslContextFactory()` |
    `JsonObject` | `toJson()` |

    - ### Methods inherited from class io.vertx.core.net.SSLEngineOptions

      `getUseWorkerThread`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_SESSION_CACHE_ENABLED

          public static final boolean DEFAULT_SESSION_CACHE_ENABLED

      Default value of whether session cache is enabled in open SSL session server context = true
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### OpenSSLEngineOptions

          public OpenSSLEngineOptions()

    - #### OpenSSLEngineOptions

          public OpenSSLEngineOptions​(JsonObject json)

    - #### OpenSSLEngineOptions

          public OpenSSLEngineOptions​(OpenSSLEngineOptions other)

  - ### Method Detail

    - #### isAvailable

          public static boolean isAvailable()

      Returns:
        when OpenSSL is available

    - #### isAlpnAvailable

          public static boolean isAlpnAvailable()

      Returns:
        when alpn support is available via OpenSSL engine

    - #### setSessionCacheEnabled

          public OpenSSLEngineOptions setSessionCacheEnabled​(boolean sessionCacheEnabled)

      Set whether session cache is enabled in open SSL session server context
      Parameters:
        `sessionCacheEnabled` - true if session cache is enabled
      Returns:
        a reference to this, so the API can be used fluently

    - #### isSessionCacheEnabled

          public boolean isSessionCacheEnabled()

      Whether session cache is enabled in open SSL session server context
      Returns:
        true if session cache is enabled

    - #### setUseWorkerThread

          public OpenSSLEngineOptions setUseWorkerThread​(boolean useWorkerThread)

      Description copied from class: `SSLEngineOptions`
      Set the thread pool to use for SSL blocking operations.
      Overrides:
        `setUseWorkerThread` in class `SSLEngineOptions`
      Parameters:
        `useWorkerThread` - whether to use the vertx internal worker pool for SSL blocking operations
      Returns:
        a reference to this, so the API can be used fluently

    - #### toJson

          public JsonObject toJson()

    - #### copy

          public OpenSSLEngineOptions copy()

      Specified by:
        `copy` in class `SSLEngineOptions`

    - #### sslContextFactory

          public SslContextFactory sslContextFactory()

      Specified by:
        `sslContextFactory` in class `SSLEngineOptions`
      Returns:
        a `SslContextFactory` that will be used to produce the Netty `SslContext`